/* C code produced by gperf version 2.7.2 */
/* Command-line: gperf -c -N lookup_keyword -t -D keywords.gperf  */
/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 539 $ $LastChangedDate: 2002-08-25 13:25:13 +0200 (Sun, 25 Aug 2002) $
 *
 * Keyword.gperf - List of keyword recognised by Gont compiler.
 */

#include "parser.h"
#include <string.h>
struct keyword;
struct keyword *lookup_keyword(const char*, unsigned int);
struct keyword { char *name; int tok; };

#define TOTAL_KEYWORDS 36
#define MIN_WORD_LENGTH 2
#define MAX_WORD_LENGTH 10
#define MIN_HASH_VALUE 4
#define MAX_HASH_VALUE 59
/* maximum key range = 56, duplicates = 2 */

#ifdef __GNUC__
__inline
#else
#ifdef __cplusplus
inline
#endif
#endif
static unsigned int
hash (str, len)
     register const char *str;
     register unsigned int len;
{
  static unsigned char asso_values[] =
    {
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 15, 10,
      10,  0, 20, 10, 35, 30, 60,  0, 25, 60,
      25, 30,  0, 60,  5, 15,  5,  5, 15,  0,
      60,  0, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60, 60, 60, 60, 60,
      60, 60, 60, 60, 60, 60
    };
  return len + asso_values[(unsigned char)str[len - 1]] + asso_values[(unsigned char)str[0]];
}

#ifdef __GNUC__
__inline
#endif
struct keyword *
lookup_keyword (str, len)
     register const char *str;
     register unsigned int len;
{
  static struct keyword wordlist[] =
    {
      {"else", KW_ELSE},
      {"while", KW_WHILE},
      {"try", KW_TRY},
      {"true", KW_TRUE},
      {"type", KW_TYPE},
      {"raise", KW_RAISE},
      {"case", KW_CASE},
      {"continue", KW_CONTINUE},
      {"extern_c", KW_EXTERN_C},
      {"skip", KW_SKIP},
      {"break", KW_BREAK},
      {"export_as", KW_EXPORT_AS},
      {"false", KW_FALSE},
      {"struct", KW_STRUCT},
      {"finally", KW_FINALLY},
      {"for", KW_FOR},
      {"void", KW_VOID},
      {"float", KW_FLOAT},
      {"string", KW_STRING},
      {"typedef", KW_TYPEDEF},
      {"let", KW_LET},
      {"exception", KW_EXCEPTION},
      {"union", KW_UNION},
      {"return", KW_RETURN},
      {"int", KW_INT},
      {"with", KW_WITH},
      {"do", KW_DO},
      {"bool", KW_BOOL},
      {"opt_struct", KW_OPT_STRUCT},
      {"section", KW_SECTION},
      {"fun", KW_FUN},
      {"if", KW_IF},
      {"null", KW_NULL},
      {"switch", KW_SWITCH},
      {"in", KW_IN},
      {"open", KW_OPEN}
    };

  static short lookup[] =
    {
       -1,  -1,  -1,  -1,   0,   1,  -1,  -1,   2, -48,
        5, -33,  -2,  -1,   6,  -1,  -1,  -1, -58,   9,
       10, -29,  -2,  -1,  11,  12,  13,  14,  15,  16,
       17,  18,  19,  20,  21,  22,  23,  -1,  24,  25,
       -1,  -1,  26,  -1,  27,  28,  -1,  29,  30,  -1,
       -1,  -1,  31,  -1,  32,  -1,  33,  34,  -1,  35
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register int index = lookup[key];

          if (index >= 0)
            {
              register const char *s = wordlist[index].name;

              if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
                return &wordlist[index];
            }
          else if (index < -TOTAL_KEYWORDS)
            {
              register int offset = - 1 - TOTAL_KEYWORDS - index;
              register struct keyword *wordptr = &wordlist[TOTAL_KEYWORDS + lookup[offset]];
              register struct keyword *wordendptr = wordptr + -lookup[offset + 1];

              while (wordptr < wordendptr)
                {
                  register const char *s = wordptr->name;

                  if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
                    return wordptr;
                  wordptr++;
                }
            }
        }
    }
  return 0;
}
