/* 
 * Copyright (c) 2002 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 560 $ $LastChangedDate: 2002-08-25 18:07:52 +0200 (Sun, 25 Aug 2002) $
 *
 * Runtime environment for Gont, Std module interface.
 * 
 * This module is opened at the beginning of every compilation unit.
 */
 
string itoa(int) = "Std__itoa";
int atoi(string) = "Std__atoi";

string ftoa(float) = "Std__ftoa";
float atof(string) = "Std__atof";

void print_string(string) = "Std__print_string";
void print_int(int);
void print_float(float);
void print_endline(string);
void print_newline();

void prerr_string(string) = "Std__prerr_string";
void prerr_int(int);
void prerr_float(float);
void prerr_endline(string);
void prerr_newline();

string read_line() = "Std__read_line";
int read_int();
float read_float();

union <'a>option {
	void None;
	'a Some;
}

'a fst(*['a, 'b]);
'b snd(*['a, 'b]);

exception void Match_failure
exception void Null_access
exception string Invalid_argument
exception string Failure
exception string Sys_error
exception void Not_found
exception void Exit
exception void End_of_file

type char;
char char_of_int(int x);
int int_of_char(char x);
