/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 539 $ $LastChangedDate: 2002-08-25 13:25:13 +0200 (Sun, 25 Aug 2002) $
 *
 * Standard library for Gont, Array module implementation.
 */

open Array;

void iter(*(void ('a)) f, <'a>t array)
{
	int sz = length(array);
	
	for (int i = 0; i < sz; i++)
		f(get(array, i));
}

<'a>List::t to_list(<'a>t array)
{
	<'a>List::t make(<'a>List::t ret, int pos) {
		if (pos < 0)
			return ret;
		else
			return make(List::Cons[get(array, pos), ret], 
				    pos - 1);
	}

	return make(List::Nil, length(array) - 1);
}

<'a>t of_list(<'a>List::t lst)
{
	switch lst {
	case List::Nil:
		raise Invalid_argument["Array::of_list"];
	case List::Cons[hd, _]:
		<'a>t ret = make(List::length(lst), hd);
		void init(<'a>List::t ll, int pos) {
			switch ll {
			case List::Nil:
				return;
			case List::Cons[x, xs]:
				set(ret, pos, x);
				init(xs, pos + 1);
			}
		}
		init(lst, 0);
		return ret;
	}
}
